//+------------------------------------------------------------------+
//|   SMI Alerts & Arrows                                            |
//|   Based On William Blau & Mladen SMI                             |
//|                                                                  |
//|   Copyright  2014 / airquest@hotmail.com                        |
//|                                                                  |
//|   http://smart-trading.world-record.ch                           |
//+------------------------------------------------------------------+


   #property copyright "Copyright  2014 // airquest // smart-trading.world-record.ch"
   #property link      "http://smart-trading.world-record.ch"


//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  Lime
#property indicator_width1  2
#property indicator_color2  Red
#property indicator_width2  2


extern ENUM_TIMEFRAMES TimeFrame = PERIOD_CURRENT;
extern int     Length      = 5;
extern int     Smooth1     = 3;
extern int     Smooth2     = 3;
extern int     Signal      = 3;
extern ENUM_APPLIED_PRICE Price = PRICE_CLOSE;
extern double  OverBought1 =  48.2;
extern double  OverSold1   = -48.2;
extern double  OverBought2 =    60;
extern double  OverSold2   =   -60;

extern bool    ShowArrows                  = True;
extern bool    ArrowsOnlyOnOBOSCrosses     = True;
extern bool    TakeOBOSLevel1_Not2         = True;
extern double  ArrowDisplacement           = 1.0;
extern int     ArrowsUpCode                = 233;
extern int     ArrowsDnCode                = 234;

extern bool    AlertsOn                    = True;
extern bool    AlertsOnCurrent             = False;
extern bool    AlertsOnlyOnOBOSCrosses     = True;
extern bool    AlertsOnOBOSLevel1_Not2     = True;
extern bool    AlertsMessage               = True;
extern bool    AlertsEmail                 = False;
extern bool    AlertsSound                 = False;

extern bool   ArrowsOnFirstBar    = true;


double smo[];
double sms[];
double tBuffer[][6];
double smoUa[];
double smoUb[];
double smoDa[];
double smoDb[];
double state[];
double trend[];
double BuySignal[];
double SellSignal[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(10);
   SetIndexBuffer(0,BuySignal);  SetIndexStyle(0,DRAW_ARROW);  SetIndexArrow(0,ArrowsUpCode);
   SetIndexBuffer(1,SellSignal); SetIndexStyle(1,DRAW_ARROW);  SetIndexArrow(1,ArrowsDnCode);
   
   SetIndexBuffer(2,smo);        SetIndexLabel(2,NULL);
   SetIndexBuffer(3,sms);        SetIndexLabel(3,NULL);
   SetIndexBuffer(4,smoUa);      SetIndexLabel(4,NULL);
   SetIndexBuffer(5,smoUb);      SetIndexLabel(5,NULL);
   SetIndexBuffer(6,smoDa);      SetIndexLabel(6,NULL);
   SetIndexBuffer(7,smoDb);      SetIndexLabel(7,NULL);
   
   SetIndexBuffer(8,state);      SetIndexLabel(8,NULL);
   SetIndexBuffer(9,trend);      SetIndexLabel(9,NULL);

   string PriceType;
      switch(Price)
      {
         case PRICE_CLOSE:    PriceType = "Close";    break;  // 0
         case PRICE_OPEN:     PriceType = "Open";     break;  // 1
         case PRICE_HIGH:     PriceType = "High";     break;  // 2
         case PRICE_LOW:      PriceType = "Low";      break;  // 3
         case PRICE_MEDIAN:   PriceType = "Median";   break;  // 4
         case PRICE_TYPICAL:  PriceType = "Typical";  break;  // 5
         case PRICE_WEIGHTED: PriceType = "Weighted"; break;  // 6
      }

   Length  = MathMax(Length ,1);
   Smooth1 = MathMax(Smooth1,1);
   Smooth2 = MathMax(Smooth2,1);
       indicatorFileName = WindowExpertName();
       returnBars        = (TimeFrame==-99);
       TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName (" Stochastic Momentum ("+Length+","+Smooth1+","+Smooth2+","+PriceType+")");
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

#define ema10 0
#define ema11 1
#define ema12 2
#define ema20 3
#define ema21 4
#define ema22 5

int start()
{
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         int r,limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { BuySignal[0] = limit+1; return(0); }
         if (TimeFrame!=Period())
         {
            int shift = -1; if (ArrowsOnFirstBar) shift=1;
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
            for (int i=limit;i>=0; i--)
            {
               int y = iBarShift(NULL,TimeFrame,Time[i]);
               int x = iBarShift(NULL,TimeFrame,Time[i+shift]);
               if (x!=y)
               {
                  BuySignal[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Smooth1,Smooth2,Signal,Price,OverBought1,OverSold1,OverBought2,OverSold2,ShowArrows,ArrowsOnlyOnOBOSCrosses,TakeOBOSLevel1_Not2,ArrowDisplacement,ArrowsUpCode,ArrowsDnCode,AlertsOn,AlertsOnCurrent,AlertsOnlyOnOBOSCrosses,AlertsOnOBOSLevel1_Not2,AlertsMessage,AlertsEmail,AlertsSound,0,y);
                  SellSignal[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Smooth1,Smooth2,Signal,Price,OverBought1,OverSold1,OverBought2,OverSold2,ShowArrows,ArrowsOnlyOnOBOSCrosses,TakeOBOSLevel1_Not2,ArrowDisplacement,ArrowsUpCode,ArrowsDnCode,AlertsOn,AlertsOnCurrent,AlertsOnlyOnOBOSCrosses,AlertsOnOBOSLevel1_Not2,AlertsMessage,AlertsEmail,AlertsSound,1,y);
               }
               else
               {
                  BuySignal[i]  = EMPTY_VALUE;
                  SellSignal[i] = EMPTY_VALUE;
               }  
            }                               
            return(0);
         }
         

   //
   //
   //
   //
   //
   

                 if (ArrayRange(tBuffer,0) != Bars) ArrayResize(tBuffer,Bars);

         double alpha1 = 2.0 /(1.0+Smooth1);
         double alpha2 = 2.0 /(1.0+Smooth2);
         double alphas = 2.0 /(1.0+Signal);

   for(i=limit,r=Bars-i-1; i >= 0; i--,r++)
   {
      double hh = High[iHighest(NULL,0,MODE_HIGH,Length,i)];
      double ll =  Low[ iLowest(NULL,0,MODE_LOW ,Length,i)];
      double pr = iMA(NULL,0,1,0,MODE_SMA,Price,i);

         tBuffer[r][ema10] = pr - 0.5*(hh+ll);
         tBuffer[r][ema20] =           hh-ll;
         if (i>=Bars-3)
         {
            tBuffer[r][ema11] = tBuffer[r][ema10];
            tBuffer[r][ema12] = tBuffer[r][ema10];
            tBuffer[r][ema21] = tBuffer[r][ema20];
            tBuffer[r][ema22] = tBuffer[r][ema20];
            continue;
         }
      
      tBuffer[r][ema11] = tBuffer[r-1][ema11] + alpha1*(tBuffer[r][ema10]-tBuffer[r-1][ema11]);
      tBuffer[r][ema12] = tBuffer[r-1][ema12] + alpha2*(tBuffer[r][ema11]-tBuffer[r-1][ema12]);
      tBuffer[r][ema21] = tBuffer[r-1][ema21] + alpha1*(tBuffer[r][ema20]-tBuffer[r-1][ema21]);
      tBuffer[r][ema22] = tBuffer[r-1][ema22] + alpha2*(tBuffer[r][ema21]-tBuffer[r-1][ema22]);

         smo[i] = 100.00 * tBuffer[r][ema12] / (0.5 * tBuffer[r][ema22]);
         if (Signal>1)
            sms[i] = sms[i+1]+alphas*(smo[i]-sms[i+1]);
   }
   
      for(i=limit; i>=0; i--)
      {  
         BuySignal[i]  = EMPTY_VALUE;
         SellSignal[i] = EMPTY_VALUE;
         trend[i] = trend[i+1];

         if (smo[i] >  sms[i]) trend[i] =  1;
         if (smo[i] <  sms[i]) trend[i] = -1;
         if (smo[i] == sms[i]) trend[i] =  0;
         
         double gap = ArrowDisplacement * iATR(NULL,0,100,i);
         
         if(ShowArrows)
         {
            if(ArrowsOnlyOnOBOSCrosses)
            {
               if(TakeOBOSLevel1_Not2)  if ((trend[i] != trend[i+1]) && (trend[i] ==  1) && (smo[i] < OverSold1   || (smo[i+1] < OverSold1   && sms[i+1] < OverSold1)))   BuySignal[i]  = Low[i]  - gap;
               if(TakeOBOSLevel1_Not2)  if ((trend[i] != trend[i+1]) && (trend[i] == -1) && (smo[i] > OverBought1 || (smo[i+1] > OverBought1 && sms[i+1] > OverBought1))) SellSignal[i] = High[i] + gap;
               if(!TakeOBOSLevel1_Not2) if ((trend[i] != trend[i+1]) && (trend[i] ==  1) && (smo[i] < OverSold2   || (smo[i+1] < OverSold2   && sms[i+1] < OverSold2)))   BuySignal[i]  = Low[i]  - gap;
               if(!TakeOBOSLevel1_Not2) if ((trend[i] != trend[i+1]) && (trend[i] == -1) && (smo[i] > OverBought2 || (smo[i+1] > OverBought2 && sms[i+1] > OverBought2))) SellSignal[i] = High[i] + gap;
            }
            else
            {
               if ((trend[i] != trend[i+1]) && (trend[i] ==  1)) BuySignal[i]  = Low[i]  - gap;
               if ((trend[i] != trend[i+1]) && (trend[i] == -1)) SellSignal[i] = High[i] + gap;
            }
         }

      }
      if (AlertsOn)
      {
         if (AlertsOnCurrent)
            int whichBar = 0;
         else   whichBar = 1;
         if (trend[whichBar] != trend[whichBar+1])
         {
            if(AlertsOnlyOnOBOSCrosses)
            {
               if (AlertsOnOBOSLevel1_Not2  && trend[whichBar] ==  1 && (smo[whichBar] < OverSold1   || (smo[whichBar+1] < OverSold1   && sms[whichBar+1] < OverSold1)))   doAlert(whichBar,"MA Cross Up");
               if (AlertsOnOBOSLevel1_Not2  && trend[whichBar] == -1 && (smo[whichBar] > OverBought1 || (smo[whichBar+1] > OverBought1 && sms[whichBar+1] > OverBought1))) doAlert(whichBar,"MA Cross Down");
               if (!AlertsOnOBOSLevel1_Not2 && trend[whichBar] ==  1 && (smo[whichBar] < OverSold2   || (smo[whichBar+1] < OverSold2   && sms[whichBar+1] < OverSold2)))   doAlert(whichBar,"MA Cross Up");
               if (!AlertsOnOBOSLevel1_Not2 && trend[whichBar] == -1 && (smo[whichBar] > OverBought2 || (smo[whichBar+1] > OverBought2 && sms[whichBar+1] > OverBought2))) doAlert(whichBar,"MA Cross Down");
            }
            else
            {
               if (trend[whichBar] ==  1) doAlert(whichBar,"MA Cross Up");
               if (trend[whichBar] == -1) doAlert(whichBar,"MA Cross Down");
            }         
         }
      }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="Nothing";
   static datetime previousTime;
   string message;

   if (previousAlert != doWhat || previousTime != Time[forBar])
   {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       message =  StringConcatenate(timeFrameToString(_Period)+" "+Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ",Symbol()," ",Period()," SMI ",doWhat);
          if (AlertsMessage) Alert(message);
          if (AlertsEmail)   SendMail(StringConcatenate(Symbol(),"SMI "),message);
          if (AlertsSound)   PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}